//#include "config.h"
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>

/*
#include <sys/time.h>
#include "common.h"
#include "image.h"
#include "rend.h"
#include "rgba.h"
#include "ximage.h"
#include "color.h"
 */
#include "Imlib2.h"

void exposelist(void);


Display            *disp;
Window              win;
Visual             *vis;
Colormap            cm;
int                 depth;
XSetWindowAttributes attr;
char *appToRun;

int main(int argc, char **argv)
{
   int                 w, h, x, y;
   Imlib_Image         im_bg = NULL;
   XEvent              ev;
   const char         *display_name = getenv("DISPLAY");
   Imlib_Image         buffer;


   if (display_name == NULL)
       display_name = ":0";
   disp = XOpenDisplay(display_name);
   if (disp == NULL)
     {
       fprintf(stderr, "Can't open display %s\n", display_name);
       return 1;
     }

int screen=DefaultScreen(disp);
int screenWidth=0;
screenWidth=XDisplayWidth(disp,screen);
screenWidth=64;
int screenHeight;
screenHeight=64;
int screenX=10;
int screenY=10;
int lowerraise=0;
int group=0;
char *picname;
int hidemode=0;
int submode=0;

int store=0;

char home[1024];
sprintf(home,"%s",getenv("HOME"));
char wxbasic[1024];

//----arguments x y width height lower/raise(0/1) picture hidemode
        if ( argc != 10 ){

          printf("usage: iconrun1 x y width height lower/raise(0/1) group image applicationToRun hidemode submode\n");
          return 1;
        }
        printf("ok\n");
        sscanf(argv[1], "%d", &screenX);
        sscanf(argv[2], "%d", &screenY);
        sscanf(argv[3], "%d", &screenWidth);
        sscanf(argv[4], "%d", &screenHeight);
        sscanf(argv[5], "%d", &lowerraise);
        sscanf(argv[6], "%d", &group);
        picname = argv[7];
        sscanf(argv[8], "%d", &hidemode);
        sscanf(argv[9], "%d", &submode);



   vis = DefaultVisual(disp, DefaultScreen(disp));
   depth = DefaultDepth(disp, DefaultScreen(disp));
   cm = DefaultColormap(disp, DefaultScreen(disp));

 attr.override_redirect=True;
 
//win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,CopyFromParent,InputOutput,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask|CWBorderPixel|CWSaveUnder|CWColormap|CWBackPixel,&attr);
win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);


//   win =  XCreateSimpleWindow(disp, DefaultRootWindow(disp), 0, 0, 100, 100, 0, 0, 0);

   XSelectInput(disp, win, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);

   XMapWindow(disp, win);

if(lowerraise==0)
   XLowerWindow(disp,win);
if(lowerraise==1)
   XRaiseWindow(disp,win);

if(hidemode==1)
   XMoveWindow(disp,win,-screenWidth+2 , screenY);

   /**
    * Start rendering
    */
   printf("Rendering\n");
   imlib_context_set_display(disp);
   imlib_context_set_visual(vis);
   imlib_context_set_colormap(cm);
   imlib_context_set_drawable(win);
   imlib_context_set_dither(1);
   imlib_context_set_blend(0);
   imlib_context_set_color_modifier(NULL);


//--
w=screenWidth;
h=screenHeight;
   buffer = imlib_load_image("../pics/background.jpg");
   imlib_context_set_image(buffer);
                buffer = imlib_create_cropped_scaled_image(0, 0,imlib_image_get_width() ,imlib_image_get_height() ,
                       w , h);

   im_bg = imlib_load_image(picname);

   XMapWindow(disp, win);

   imlib_context_set_image(im_bg);


   imlib_context_set_image(im_bg);
                im_bg = imlib_create_cropped_scaled_image(0, 0,imlib_image_get_width() ,imlib_image_get_height() ,
                       w , h);

             imlib_context_set_blend(1);

   imlib_context_set_image(buffer);
                imlib_blend_image_onto_image (im_bg,0,0, 0,imlib_image_get_width() ,imlib_image_get_height() ,
                       0,0,w , h);
   imlib_context_set_image(buffer);
                buffer = imlib_create_cropped_scaled_image(0, 0,imlib_image_get_width() ,imlib_image_get_height() ,
                       w , h);
   imlib_context_set_image(im_bg);
                imlib_blend_image_onto_image (buffer,0,0, 0,imlib_image_get_width() ,imlib_image_get_height() ,
                       0,0,w , h);



        imlib_context_set_image(im_bg);
        imlib_render_image_on_drawable(0, 0);



   XResizeWindow(disp, win, w, h);
   XSync(disp, False);
   x = -9999;
   y = -9999;
   x = -screenWidth/2;
   y = -screenHeight/2;
   while (1)
     {
        Imlib_Image        temp, temp2;

        do
          {
             XNextEvent(disp, &ev);
             switch (ev.type)
               {
                 case Expose:

                    break;
 
                 case MotionNotify:
                    x = ev.xmotion.x;
                    y = ev.xmotion.y;
                 default:
                    break;

                 case EnterNotify:		
                    x = ev.xmotion.x;
                    y = ev.xmotion.y;
system("killall iconrun2b 2>/dev/null");	
system("killall iconrun2a 2>/dev/null");	
if (submode==1){
  sprintf(wxbasic,"./menue.sh START %s",home);
  system(wxbasic);
}

if(hidemode==1)
   XMoveWindow(disp,win,screenX , screenY);
                    break;

                 case LeaveNotify:		

                   x = -screenWidth/2;
                   y = -screenHeight/2;		

if(hidemode==1)
   XMoveWindow(disp,win,-screenWidth+2 , screenY);

                    break;

                 case ButtonPress:				
                          if(ev.xbutton.button==1)
				{

if((store==1) and (submode==0)){

system("killall iconrun2d 2>/dev/null");	
system("killall iconrun2c 2>/dev/null");	
system("killall iconrun2b 2>/dev/null");	
system("killall iconrun2a 2>/dev/null");	
system("killall iconrun2 2>/dev/null");	
store=0;
break;
}
sprintf(wxbasic,"./menue.sh START %s",home);
system(wxbasic);

store+=1;


				}
                        if(ev.xbutton.button==3)
				{
                                    /* if we click anywhere in the window, exit */
system("killall iconrun2d 2>/dev/null");	
system("killall iconrun2c 2>/dev/null");	
system("killall iconrun2b 2>/dev/null");	
system("killall iconrun2a 2>/dev/null");	
system("killall iconrun2 2>/dev/null");	
sprintf(wxbasic,"./menue.sh INIT %s",home);
system(wxbasic);
                                   exit(0);
                                   break;
                                }

               }
          }
        while (XPending(disp));

        imlib_context_set_blend(0);
        imlib_context_set_image(im_bg);
        temp = imlib_clone_image();
        imlib_context_set_image(temp);



        imlib_apply_filter
//         ("bump_map_point(x=[],y=[],map=""/tmp/backbump.jpg);", &x, &y);


         ("bump_map_point(x=[],y=[],map=""blend.jpg);", &x, &y);

      
   
 //        ("bump_map_point(x=[],y=[],map="PACKAGE_DATA_DIR"/data/images/imlib2.png);", &x, &y);


          

        temp2 = im_bg;
        im_bg = temp;
        imlib_context_set_image(im_bg);
        imlib_render_image_on_drawable(0, 0);
        im_bg = temp2;
        imlib_context_set_image(temp);
        imlib_free_image();
     }

   return 0;
}

void exposelist(void){
  //printf("exposelist\n");
  char app[2000];
  sprintf(app,"%s &",appToRun);
  system(app);
}
