#!/bin/bash

echo '#!/bin/bash' > aaaaa
mode=1
home=""
if [ "$1" = "INIT" ]; then
  mode=2
  home=$2
else
  if [ "$1" = "START" ]; then
    echo "starting"
    mode=0
    home=$2
  else
    size=40 #unused in this program
    x=$1
    y=$2
    selectedgroup=$3
    raisemode=$4
    home="$5"
  fi
fi
if [ -z $home ]; then
  echo "fatal error: no /home/xxx found!"
  exit
fi
home="$home/.iconmenu/bin"
cd $home

i=0
gc=0
s=""

while read buffer
do
  if [ -n "$buffer" ]; then
    if [ "${buffer:0:1}" != "#" ]; then
      if [ "${buffer:0:11}" = "baseconfig:" ]; then
        buffer0=${buffer#baseconfig:}
        xmain=`echo $buffer0|awk '{ print $1;}'`
        ymain=`echo $buffer0|awk '{ print $2;}'`
        sizemain=`echo $buffer0|awk '{ print $3;}'`
        gapmain=`echo $buffer0|awk '{ print $4;}'`
        sizesub=`echo $buffer0|awk '{ print $5;}'`
        gapsub=`echo $buffer0|awk '{ print $6;}'`
        raisemode=`echo $buffer0|awk '{ print $7;}'`
        autohidemainbutton=`echo $buffer0|awk '{ print $8;}'`
        autohideSubbutton=`echo $buffer0|awk '{ print $9;}'`
      fi
      if [ "${buffer:0:5}" = "group" ]; then
        group=`echo $buffer|awk '{ print $1;}'`
        result=${buffer#$group}
        group=${group#group}
        group=${group%#}
        if [ $mode -eq 2 ]; then
          echo "./iconrun1" $xmain $[ $ymain+$[ $gc * $[ $sizemain+$gapmain ] ] ] $sizemain $sizemain $raisemode $group $result $autohidemainbutton $autohideSubbutton '&' >> aaaaa
        fi
        if [ $mode -eq 0 ]; then
          if [ $group -gt 0 ]; then
            echo "./iconrun2 " $xmain $[ $ymain+$[ $[ $gc+1 ] * $[ $sizemain+$gapmain ] ] ] $sizemain $sizemain $raisemode $group $result '&' >> aaaaa
            let "gc=$gc+1"
          fi
        fi
      else
        if [ "${buffer:0:6}" = "single" ]; then
          if [ $mode -eq 0 ]; then
            group=`echo $buffer|awk '{ print $1;}'`
            result=${buffer#$group}
            group=${group#single}
            group=${group%#}
            if [ $group>0 ]; then
              if [ $autohideSubbutton -eq 0 ]; then
                echo "./iconrun2c" $xmain $[ $ymain+$[ $[ $gc+1 ] * $[ $sizemain+$gapmain ] ] ] $sizemain $sizemain $raisemode $result '&' >> aaaaa
              else
                echo "./iconrun2d" $xmain $[ $ymain+$[ $[ $gc+1 ] * $[ $sizemain+$gapmain ] ] ] $sizemain $sizemain $raisemode $result '&' >> aaaaa
              fi
              let "gc=$gc+1"
            fi
          fi
        else
          if [ $mode -eq 1 ]; then
            if [ $group -eq $selectedgroup ]; then
              if [ $autohideSubbutton -eq 0 ]; then
                echo "./iconrun2a" $[ $x+$gapsub+$[ $[ $sizesub+$gapsub ] * $i ] ] $[ $y-$[ $[ $sizesub-$sizemain ] / 2 ] ] $sizesub $sizesub $raisemode $buffer '&' >> aaaaa
              else
                echo "./iconrun2b" $[ $x+$gapsub+$[ $[ $sizesub+$gapsub ] * $i ] ] $[ $y-$[ $[ $sizesub-$sizemain ] / 2 ] ] $sizesub $sizesub $raisemode $buffer '&' >> aaaaa
              fi
              let "i=$i+1"
            fi
          fi
        fi
      fi
    fi
  fi
done < ../menu.rc
./aaaaa
